;************************************************************************
;*									*
;*	DV-GLUE		DESQview and DESQview/X Function Library	*
;*			(c) Copyright 1992 Ralf Brown			*
;*			All Rights Reserved.				*
;*									*
;*	File STREAMSL.ASM  stream funcs selecting between opposites	*
;*									*
;************************************************************************
;LastEdit: 12/29/92

	INCLUDE	API.INC
	INCLUDE DVSTREAM.INC
	MIN_VERSION 2,00

	Header@

;========================================================================

DSeg@
S_WINDOW	scrolltext_stream
	WS_SCROLLTEXT
	S_END	scrolltext_stream

S_WINDOW	scrollattr_stream
	WS_SCROLLATTR
	S_END	scrollattr_stream

S_WINDOW	partframe_stream
	WS_PARTFRAME
	S_END	partframe_stream

S_WINDOW	fullframe_stream
	WS_FULLFRAME
	S_END	fullframe_stream

S_WINDOW	autocolor_stream
	WS_AUTOCOLOR
	S_END	autocolor_stream

S_WINDOW	progcolor_stream
	WS_PROGCOLOR
	S_END	progcolor_stream

S_WINDOW	attr_stream
	WS_READATTR
	S_END	attr_stream

S_WINDOW	char_stream
	WS_READCHAR
	S_END	char_stream

S_WINDOW	leave_stream
	WS_LEAVEATTR
	S_END	leave_stream

S_WINDOW	write_stream
	WS_WRITEATTR
	S_END	write_stream

S_WINDOW	logattr_stream
	WS_LOGATTR
	S_END	logattr_stream

S_WINDOW	physattr_stream
	WS_PHYSATTR
	S_END	physattr_stream

S_WINDOW	frame_stream
	WS_FRAME
	S_END	frame_stream

S_WINDOW	noframe_stream
	WS_NOFRAME
	S_END	noframe_stream

S_WINDOW	ctrl_stream
	WS_CTRLCHAR
	S_END	ctrl_stream

S_WINDOW	noctrl_stream
	WS_NOCTRLCHAR
	S_END	noctrl_stream

S_MANAGER	fore_stream
	MS_FOREONLY
	S_END	fore_stream

S_MANAGER	back_stream
	MS_NOFOREONLY
	S_END	back_stream

DSegEnd@

;========================================================================

CSeg@

PubProc@ DVWIN_SCROLLATTR,__PASCAL__
	mov	bx,offset DGROUP:scrolltext_stream
	mov	cx,offset DGROUP:scrollattr_stream
	jmp short set_mode
EndProc@ DVWIN_SCROLLATTR,__PASCAL__

PubProc@ DVWIN_FULLFRAME,__PASCAL__
	mov	bx,offset DGROUP:partframe_stream
	mov	cx,offset DGROUP:fullframe_stream
	jmp short set_mode
EndProc@ DVWIN_FULLFRAME,__PASCAL__

PubProc@ DVWIN_PROGCOLOR,__PASCAL__
	mov	bx,offset DGROUP:autocolor_stream
	mov	cx,offset DGROUP:progcolor_stream
	jmp short set_mode
EndProc@ DVWIN_PROGCOLOR,__PASCAL__

PubProc@ DVWIN_LEAVE,__PASCAL__
	mov	bx,offset DGROUP:leave_stream
	mov	cx,offset DGROUP:write_stream
	jmp short set_mode
EndProc@ DVWIN_LEAVE,__PASCAL__

PubProc@ DVWIN_LOGATTR,__PASCAL__
	mov	bx,offset DGROUP:logattr_stream
	mov	cx,offset DGROUP:physattr_stream
	jmp short set_mode
EndProc@ DVWIN_LOGATTR,__PASCAL__

PubProc@ DVWIN_FRAME,__PASCAL__
	mov	bx,offset DGROUP:frame_stream
	mov	cx,offset DGROUP:noframe_stream
	jmp short set_mode
EndProc@ DVWIN_FRAME,__PASCAL__

PubProc@ DVWIN_CTRL,__PASCAL__
	mov	bx,offset DGROUP:ctrl_stream
	mov	cx,offset DGROUP:noctrl_stream
	jmp short set_mode
EndProc@ DVWIN_CTRL,__PASCAL__

PubProc@ DVFOREONLY,__PASCAL__
	mov	bx,offset DGROUP:fore_stream
	mov	cx,offset DGROUP:back_stream
	jmp short set_mode
EndProc@ DVFOREONLY,__PASCAL__

PubProc@ DVWIN_ATREAD,__PASCAL__
@win = dword ptr [bp+SendOverhead+2]
@mode = word ptr [bp+SendOverhead]
	mov	bx,offset DGROUP:attr_stream
	mov	cx,offset DGROUP:char_stream
set_mode:
	@EnterSend
	mov	ax,@mode
	or	ax,ax
	jnz	go_set_mode
	mov	bx,cx
go_set_mode:
	WIN_STREAM @win,ds,bx
	@ExitSend 6
EndProc@ DVWIN_ATREAD,__PASCAL__

CSegEnd@

	END
